<?php
/*
Plugin Name: Random Posts From Category
Plugin URI: http://www.matusiak.eu/numerodix/blog/index.php/2006/12/04/random-posts-from-category/
Description: Displays a list of three random posts from the same category. Usage: random_posts_from_category($p = $post->ID); Based on code from Alexander Malov (http://www.w-a-s-a-b-i.com/)
Version: 1.2
Author: Martin Matusiak
Author URI: http://www.matusiak.eu/numerodix
*/


function random_posts_from_category ($p, $num = 3, $before_title = '<li>', $after_title = '</li>') {
	global $wpdb, $tableposts;
	$sql = "SELECT ID, post_title, post_content FROM $tableposts ";
	
	$join = " INNER JOIN $wpdb->post2cat ON $wpdb->posts.ID= $wpdb->post2cat.post_id ";
	$cat_array = get_the_category($post->ID);
	$join .= ' AND (category_id = ' . intval($cat_array[0]->cat_ID);
	for ( $i = 1; $i < (count($cat_array)); $i++ ) {
		$join .= ' OR category_id = ' . intval($cat_array[$i]->cat_ID);
	}
	$join .= ')';
	$sql .= " $join ";
	
	$sql .= "WHERE post_status = 'publish' ";
	$sql .= "AND ID != $p ";
	$sql .= "ORDER BY RAND() LIMIT $num";

// 	echo $sql;

	$posts = $wpdb->get_results($sql);
	$output = '';
	foreach ($posts as $post) {
		$post_title = stripslashes($post->post_title);
		$post_title = str_replace('"', '', $post_title);
		$permalink = get_permalink($post->ID);
		$post_content = strip_tags($post->post_content);
		$post_content = stripslashes($post_content);
		$output .= $before_title . '<a href="' . $permalink . '" rel="bookmark" title="' . $post_title . '">' . $post_title . '</a>' . $after_title;
	}
	
	echo '<div class="random_posts_header">:: random entries in this category ::</div>';
	echo '<div class="random_posts"><ul>' . $output . '</ul></div>';
}
?>
